//+------------------------------------------------------------------+
//|                                                           BB.mq5 |
//|                        Copyright 2009, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright   "2009, MetaQuotes Software Corp."
#property link        "http://www.mql5.com"
#property description "doc BB"
#include <MovingAverages.mqh>
//---
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_plots   7
#property indicator_type1   DRAW_LINE
#property indicator_color1  Red
#property indicator_style1  STYLE_DOT // Line style
#property indicator_type2   DRAW_LINE
#property indicator_color2  Yellow
#property indicator_type3   DRAW_LINE
#property indicator_color3  Yellow
#property indicator_type4   DRAW_LINE
#property indicator_color4  Lime
#property indicator_type5   DRAW_LINE
#property indicator_color5  Lime
#property indicator_type6   DRAW_LINE
#property indicator_color6  Purple
#property indicator_type7   DRAW_LINE
#property indicator_color7  Purple
#property indicator_label1  "FrAMA"
#property indicator_label2  "Bands upper"
#property indicator_label3  "Bands lower"
#property indicator_label4  "Bands upper2"
#property indicator_label5  "Bands lower2"
#property indicator_label6  "Bands upper3"
#property indicator_label7  "Bands lower3"
#property indicator_applied_price PRICE_CLOSE
//--- input parametrs
input int     InpBandsPeriod=20;        // Period
input int     InpBandsShift=0;          // Shift
input double  InpBandsDeviations1=1.0;  // Deviation1
input double  InpBandsDeviations2=2.0;  // Deviation2
input double  InpBandsDeviations3=3.0;  // Deviation3
input int     InpPeriodFrAMA=20;        // FrAMA period
input int     InpShift=0;               // Indicator's shift
//--- global variables
int           ExtBandsPeriod,ExtBandsShift;
double        ExtBandsDeviations1;
double        ExtBandsDeviations2;
double        ExtBandsDeviations3;
int           ExtPlotBegin=0;
//---- indicator buffer
double        ExtMLBuffer[];
double        ExtTLBuffer1[];
double        ExtBLBuffer1[];
double        ExtTLBuffer2[];
double        ExtBLBuffer2[];
double        ExtTLBuffer3[];
double        ExtBLBuffer3[];
double        ExtStdDevBuffer[];
double        High[];
double        Low[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//--- check for input values
   if(InpBandsPeriod<2)
     {
      ExtBandsPeriod=20;
      printf("Incorrect value for input variable InpBandsPeriod=%d. Indicator will use value=%d for calculations.",InpBandsPeriod,ExtBandsPeriod);
     }
   else ExtBandsPeriod=InpBandsPeriod;
   if(InpBandsShift<0)
     {
      ExtBandsShift=0;
      printf("Incorrect value for input variable InpBandsShift=%d. Indicator will use value=%d for calculations.",InpBandsShift,ExtBandsShift);
     }
   else
      ExtBandsShift=InpBandsShift;
   if(InpBandsDeviations1==0.0)
     {
      ExtBandsDeviations1=2.0;
      printf("Incorrect value for input variable InpBandsDeviations=%f. Indicator will use value=%f for calculations.",InpBandsDeviations1,ExtBandsDeviations1);
     }
   else ExtBandsDeviations1=InpBandsDeviations1;
        ExtBandsDeviations2=InpBandsDeviations2;
        ExtBandsDeviations3=InpBandsDeviations3;

//--- define buffers
   SetIndexBuffer(0,ExtMLBuffer);
   SetIndexBuffer(1,ExtTLBuffer1);
   SetIndexBuffer(2,ExtBLBuffer1);
   SetIndexBuffer(3,ExtTLBuffer2);
   SetIndexBuffer(4,ExtBLBuffer2);
   SetIndexBuffer(5,ExtTLBuffer3);
   SetIndexBuffer(6,ExtBLBuffer3);
   SetIndexBuffer(7,ExtStdDevBuffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(8,High,INDICATOR_CALCULATIONS);
   SetIndexBuffer(9,Low,INDICATOR_CALCULATIONS);
//--- sets first bar from what index will be drawn
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,2*InpPeriodFrAMA-1);
//--- sets indicator shift
   PlotIndexSetInteger(0,PLOT_SHIFT,InpShift);
//--- set index labels
   PlotIndexSetString(0,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") FrAMA");
   PlotIndexSetString(1,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper");
   PlotIndexSetString(2,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower");
   PlotIndexSetString(3,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper2");
   PlotIndexSetString(4,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower2");   
   PlotIndexSetString(5,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper3");
   PlotIndexSetString(6,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower3");
//--- indicator name
   IndicatorSetString(INDICATOR_SHORTNAME,"doc BB");
//--- indexes draw begin settings
   ExtPlotBegin=ExtBandsPeriod-1;
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,ExtBandsPeriod);
//--- indexes shift settings
   PlotIndexSetInteger(0,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(1,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(2,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(3,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(4,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(5,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(6,PLOT_SHIFT,ExtBandsShift);
//--- number of digits of indicator value
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---- OnInit done
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- variables
   int pos;
//--- indexes draw begin settings, when we've recieved previous begin
   if(ExtPlotBegin!=ExtBandsPeriod+begin)
     {
      ExtPlotBegin=ExtBandsPeriod+begin;
      PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,ExtPlotBegin);
     }
//--- check for bars count
   if(rates_total<ExtPlotBegin)
      return(0);
//--- starting calculation
   if(prev_calculated>1) pos=prev_calculated-1;
   else pos=0;

//--- preparing calculation
   int limit,copied;
   double Hi1,Hi2,Hi3,Lo1,Lo2,Lo3;
   double N1,N2,N3,D;
   double ALFA;
//--- load High
   if(IsStopped()) return(0); //Checking for stop flag
   copied=CopyHigh(_Symbol,_Period,0,rates_total,High);
   if(copied!=rates_total)
     {
      Print("Can't load High prices.");
      return(0);
     }
//--- load Low
   if(IsStopped()) return(0); //Checking for stop flag
   copied=CopyLow(_Symbol,_Period,0,rates_total,Low);
   if(copied!=rates_total)
     {
      Print("Can't load Low prices.");
      return(0);
     }
//--- start calculations
   if(prev_calculated==0)
     {
      limit=2*InpPeriodFrAMA-1;
      //--- fill in indicator array 
      for(int i=0;i<=limit;i++)
         ExtMLBuffer[i]=price[i];
     }
   else limit=prev_calculated-1;
//--- main cycle
   for(int i=limit;i<rates_total && !IsStopped();i++)
     {
      Hi1=iHighest(i,InpPeriodFrAMA);
      Lo1=iLowest(i,InpPeriodFrAMA);
      Hi2=iHighest(i-InpPeriodFrAMA,InpPeriodFrAMA);
      Lo2=iLowest(i-InpPeriodFrAMA,InpPeriodFrAMA);
      Hi3=iHighest(i,2*InpPeriodFrAMA);
      Lo3=iLowest(i,2*InpPeriodFrAMA);
      N1=(Hi1-Lo1)/InpPeriodFrAMA;
      N2=(Hi2-Lo2)/InpPeriodFrAMA;
      N3=(Hi3-Lo3)/(2*InpPeriodFrAMA);
      D=(log(N1+N2)-log(N3))/log(2.0);
      ALFA=exp(-4.6*(D-1.0));
      ExtMLBuffer[i]=ALFA*price[i]+(1-ALFA)*ExtMLBuffer[i-1];
     }



//--- main cycle
   for(int i=pos;i<rates_total && !IsStopped();i++)
     {
      //--- middle line
      
      //--- calculate and write down StdDev
      ExtStdDevBuffer[i]=StdDev_Func(i,price,ExtMLBuffer,ExtBandsPeriod);
      //--- upper line1
      ExtTLBuffer1[i]=ExtMLBuffer[i]+InpBandsDeviations1*ExtStdDevBuffer[i];
      //--- lower line1
      ExtBLBuffer1[i]=ExtMLBuffer[i]-InpBandsDeviations1*ExtStdDevBuffer[i];
      //--- upper line2
      ExtTLBuffer2[i]=ExtMLBuffer[i]+InpBandsDeviations2*ExtStdDevBuffer[i];
      //--- lower line2
      ExtBLBuffer2[i]=ExtMLBuffer[i]-InpBandsDeviations2*ExtStdDevBuffer[i];
      //--- upper line3
      ExtTLBuffer3[i]=ExtMLBuffer[i]+InpBandsDeviations3*ExtStdDevBuffer[i];
      //--- lower line3
      ExtBLBuffer3[i]=ExtMLBuffer[i]-InpBandsDeviations3*ExtStdDevBuffer[i];
      //---
     }
//---- OnCalculate done. Return new prev_calculated.
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Calculate Standard Deviation                                     |
//+------------------------------------------------------------------+
double StdDev_Func(int position,const double &price[],const double &MAprice[],int period)
  {
//--- variables
   double StdDev_dTmp=0.0;
//--- check for position
   if(position<period) return(StdDev_dTmp);
//--- calcualte StdDev
   for(int i=0;i<period;i++) StdDev_dTmp+=MathPow(price[position-i]-MAprice[position],2);
   StdDev_dTmp=MathSqrt(StdDev_dTmp/period);
//--- return calculated value
   return(StdDev_dTmp);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Find the highest value in data range                             |
//+------------------------------------------------------------------+
double iHighest(int StartPos,
                int Depth)
  {
   double res;
//--- check for parameters StartPos and Depth
   if(StartPos<0 || StartPos-Depth+1<0 || Depth<0)
     {
      Print("Invalid parameter in function",__FUNCTION__,": StartPos =",StartPos,", Depth = ",Depth);
      return(0.0);
     }
//--- 
   res=High[StartPos];
   for(int i=StartPos-Depth+1;i<StartPos;i++)
      if(High[i]>res)
         res=High[i];
   return(res);
  }
//+------------------------------------------------------------------+
//| Find the lowest value in data range                              |
//+------------------------------------------------------------------+
double iLowest(int StartPos,
               int Depth)
  {
   double res;
//--- check for parameters StartPos and Depth
   if(StartPos<0 || StartPos-Depth+1<0 || Depth<0)
     {
      Print("Invalid parameter in function",__FUNCTION__,": StartPos =",StartPos,", Depth = ",Depth);
      return(0.0);
     }
//--- 
   res=Low[StartPos];
   for(int i=StartPos-Depth+1;i<StartPos;i++)
      if(Low[i]<res)
         res=Low[i];
   return(res);
  }
//+------------------------------------------------------------------+

